## gringo 3.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

# user configurables
set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type: Release Debug")
if(NOT $ENV{WITH_LUA} STREQUAL "")
	SET(WITH_LUA $ENV{WITH_LUA})
endif()
set(WITH_LUA "${WITH_LUA}" CACHE STRING "Enable LUA support (none, system, internal)")
if(NOT $ENV{WITH_LUASQL} STREQUAL "")
	SET(WITH_LUASQL TRUE)
endif()
SET(WITH_LUASQL "${WITH_LUASQL}" CACHE BOOL "Enable luasql support")
if(NOT $ENV{WITH_DOC} STREQUAL "")
	SET(WITH_DOC TRUE)
endif()
set(WITH_DOC "${WITH_DOC}" CACHE BOOL "Generate documentation")
set(USE_STATIC_LIBS "${USE_STATIC_LIBS}" CACHE BOOL "Link statically")

project(gringo)

include(cmake/re2c.cmake)
include(cmake/lemon.cmake)
include(cmake/macros.cmake)
include(cmake/PCHSupport.cmake)

ENSURE_OUT_OF_SOURCE_BUILD("you have to create an out-of-source build")

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake CACHE INTERNAL "" FORCE)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin CACHE INTERNAL "" FORCE)
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib CACHE INTERNAL "" FORCE)

IF(USE_STATIC_LIBS)
	set(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)
	set(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
	set(CMAKE_SHARED_LIBRARY_C_FLAGS)
	set(CMAKE_SHARED_LIBRARY_CXX_FLAGS)
	set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS)
	set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS)
	set(Boost_USE_STATIC_LIBS TRUE)
	set(CMAKE_EXE_LINKER_FLAGS ${CMAKE_EXE_LINKER_FLAGS} -static)
	set(CMAKE_FIND_LIBRARY_SUFFIXES .lib .a)
ENDIF()

if(CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-ignored-qualifiers")
endif()

set(Boost_USE_MULTITHREADED OFF CACHE STRING "Whether to Use multi-threaded boost libraries")
find_package(Boost REQUIRED filesystem system)
include_directories(${Boost_INCLUDE_DIRS})
if(WITH_LUA STREQUAL "system")
	find_package(LUA51 REQUIRED)
	add_definitions("-DWITH_LUA=1")
	include_directories(${LUA_INCLUDE_DIR})
elseif(WITH_LUA STREQUAL "shipped")
	add_definitions("-DWITH_LUA=2")
	include_directories(liblua)
	add_subdirectory(liblua)
	if(WITH_LUASQL)
		add_definitions("-DWITH_LUASQL")
		include_directories(${CMAKE_SOURCE_DIR}/libluasql ${CMAKE_BINARY_DIR}/libluasql)
		add_subdirectory(libluasql)
	endif()
endif()
add_subdirectory(libclasp)
add_subdirectory(libgringo)
add_subdirectory(libprogram_opts)
add_subdirectory(app)

if(WITH_DOC)
	include(cmake/UseLATEX.cmake)
	add_subdirectory(doc/guide)
endif()

=== Makefile ===
target=gringo-app
cmake_options=-DWITH_LUA=shipped -DWITH_LUASQL=1

all: release

debug:
	mkdir -p build/debug
	cd build/debug && \
		cmake ../.. \
		-DCMAKE_CXX_FLAGS="-W -Wall -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC" \
		-DCMAKE_BUILD_TYPE=debug \
		${cmake_options} && \
	$(MAKE) $(target)

release:
	mkdir -p build/release
	cd build/release && \
	cmake ../.. \
		-DCMAKE_CXX_FLAGS=-Wall \
		-DCMAKE_BUILD_TYPE=release \
		${cmake_options} && \
	$(MAKE) $(target)

static:
	mkdir -p build/static
	cd build/static && \
	cmake ../.. \
		-DCMAKE_CXX_FLAGS=-Wall \
		-DCMAKE_BUILD_TYPE=release \
		-DUSE_STATIC_LIBS=ON \
		${cmake_options} && \
	$(MAKE) $(target)

static32:
	mkdir -p build/static32
	cd build/static32 && \
	cmake ../.. \
		-DCMAKE_CXX_FLAGS="-Wall -m32" \
		-DCMAKE_FIND_ROOT_PATH="/usr/lib32;${HOME}/local/x86" \
		-DCMAKE_BUILD_TYPE=release \
		-DUSE_STATIC_LIBS=ON \
		${cmake_options} && \
	$(MAKE) $(target)

mingw32:
	@[ -x build/release/bin/lemon ] || (echo "error: make release first" && false)
	mkdir -p build/mingw32/bin
	cd build/mingw32 && \
	cmake ../.. \
		-DIMPORT_LEMON="$(PWD)/build/release/import_lemon.cmake" \
		-DCMAKE_TOOLCHAIN_FILE=../../cmake/mingw32.cmake \
		-DCMAKE_BUILD_TYPE=release \
		-DUSE_STATIC_LIBS=ON \
		${cmake_options} && \
	$(MAKE) $(target)

clean:
	rm -rf build

=== libclasp/CMakeLists.txt ===
file(GLOB_RECURSE LIBCLASP_SRC src/*.cpp *.h)

include_directories(src .)

add_library(clasp-lib STATIC ${LIBCLASP_SRC})

target_link_libraries(clasp-lib)
set_target_properties(clasp-lib PROPERTIES OUTPUT_NAME clasp)

=== libgringo/CMakeLists.txt ===
file(GLOB_RECURSE LIBGRINGO_SRC    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*.cpp *.h)
file(GLOB_RECURSE LIBGRINGO_LEXER  RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*.r2c)
file(GLOB_RECURSE LIBGRINGO_PARSER RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*.y)

include_directories(src .)

RE2C(LIBGRINGO_SRC ${LIBGRINGO_LEXER})
LEMON(LIBGRINGO_SRC ${LIBGRINGO_PARSER})

add_library(gringo-lib STATIC ${LIBGRINGO_SRC})

target_link_libraries(gringo-lib)
set_target_properties(gringo-lib PROPERTIES OUTPUT_NAME gringo)

ADD_PRECOMPILED_HEADER(gringo-lib ${CMAKE_SOURCE_DIR}/libgringo/gringo/gringo.h)

=== app/clingo/CMakeLists.txt ===
file(GLOB_RECURSE CLINGO_SRC *.cpp *.h)

add_library(appclingo-lib STATIC ${CLINGO_SRC})
set_target_properties(appclingo-lib PROPERTIES OUTPUT_NAME appclingo)

=== debian/changelog ===
gringo (3.0.3-4) unstable; urgency=low

  * control: Combine gringo, clingo, and iclingo binary packages into gringo.
   + Conflicts and Replaces clingo and iclingo.
  * copyright: Convert to DEP-5 format and add missing licenses.
  * rules: Add override_dh_installchangelogs for CHANGES file.
  * install: Install gringo, clingo and iclingo.
  * Refresh gringo-makefile.patch; do not install anything here.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 22 Feb 2011 09:38:26 +0100

gringo (3.0.3-3) unstable; urgency=low

  * Initial upload (Closes: #605879)

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 05 Dec 2010 18:01:28 +0100

gringo (3.0.3-2) unstable; urgency=low

  * Upload to mentors.debian.net.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 20 Nov 2010 09:43:35 +0100

gringo (3.0.3-1~maverick1) maverick; urgency=low

  * New upstream release.
  
  * Fix changelog entries.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 12 Nov 2010 05:53:36 +0100

gringo (3.0.2-2~maverick1) maverick; urgency=low

  * Tag distro-series.

  * Fix Standards-Version and Priority.
  
  * Suggest potassco-guide.

  * Fix missing changelog.
  
  * Add additional authors to copyright.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 10 Oct 2010 08:50:01 +0200

gringo (3.0.2-1) lucid; urgency=low

  * New upstream release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 04 Oct 2010 22:03:12 +0200

gringo (3.0.1-2) lucid; urgency=low

  * Build with system-wide liblua5.1-dev.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 28 Jul 2010 06:15:10 +0200

gringo (3.0.1-1) lucid; urgency=low

  * New upstream release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 27 Jul 2010 06:00:34 +0200

gringo (2.0.5-6) lucid; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format.
  
  * Fix lintian warning debhelper-but-no-misc-depends: add ${misc:Depends} to potassco-guide.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 06 Jun 2010 18:18:22 +0200

gringo (2.0.5-5) lucid; urgency=low

  * Added watch file.

  * Added Vcs-Bzr to control.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 01 Jun 2010 14:47:13 +0200

gringo (2.0.5-4) lucid; urgency=low

  * Set Architecture of all binary packages to "any".

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 28 May 2010 09:21:58 +0200

gringo (2.0.5-3) lucid; urgency=low

  * Set Architecture of all binary packages to "all".

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 28 May 2010 07:04:46 +0200

gringo (2.0.5-2) lucid; urgency=low

  * Moved to Ubuntu PPA.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 26 May 2010 00:33:32 +0200

gringo (2.0.5-1) unstable; urgency=low

  * Initial release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 04 Mar 2010 19:47:14 +0100

=== debian/control ===
Source: gringo
Section: interpreters
Priority: optional
Maintainer: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
Build-Depends: debhelper (>= 7.0.50~),
 cmake,
 libboost-filesystem-dev,
 libboost-system-dev,
 liblua5.1-dev
Standards-Version: 3.9.1
Vcs-Bzr: https://code.launchpad.net/~tkren/+junk/asp/gringo
Homepage: http://potassco.sourceforge.net/

Package: gringo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: clasp
Suggests: potassco-guide
Replaces: clingo, iclingo
Conflicts: clingo, iclingo
Description: grounding tools for (disjunctive) logic programs
 Current answer set solvers work on variable-free programs. Hence, a
 grounder is needed that, given an input program with first-order
 variables, computes an equivalent ground (variable-free) program.
 .
 This package contains the following tools:
 .
  - gringo: creates lparse-compatbile variable-free programs.
  - clingo: stands for clasp on gringo and combines both systems in
    a monolithic way. Its input language is that of gringo and its
    output corresponds to that of clasp.
  - iclingo: an incremental answer set programming system
    implemented on top of clingo. It is based on the idea that the
    grounder as well as the solver are implemented in a stateful way.
    Thus, both keep their previous states while increasing an
    incremental parameter. As regards grounding, at each incremental
    step, the goal is to produce only ground rules stemming from the
    current program slice, without re-producing previous ground rules.
    The ground program slices are then gradually passed to the solver
    that accumulates ground rules and computes answer sets for them.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# qa.debian.org runs a redirector which allows a simpler form of URL
# for SourceForge based projects. The format below will automatically
# be rewritten to use the redirector.
http://sf.net/potassco/gringo-([\d\.]+)-source\.tar\.gz

## gringo 3.0.4

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 target=gringo-app
-cmake_options=-DWITH_LUA=shipped -DWITH_LUASQL=1
+cmake_options=-DWITH_LUA=shipped -DWITH_LUASQL=0
 
 all: release
 
@@ -36,7 +36,7 @@
 	cd build/static32 && \
 	cmake ../.. \
 		-DCMAKE_CXX_FLAGS="-Wall -m32" \
-		-DCMAKE_FIND_ROOT_PATH="/usr/lib32;${HOME}/local/x86" \
+		-DCMAKE_FIND_ROOT_PATH="/usr/lib32;/home/wv/bin/linux/32/boost-1.44" \
 		-DCMAKE_BUILD_TYPE=release \
 		-DUSE_STATIC_LIBS=ON \
 		${cmake_options} && \

=== libluasql/CMakeLists.txt ===
file(GLOB_RECURSE LIBLUASQL_SRC *.h)
set(LIBLUASQL_SRC src/luasql.cpp ${CMAKE_CURRENT_BINARY_DIR}/luasql/luasql.h)

foreach(DRIVER SQLITE3 MYSQL ODBC)
	find_package(${DRIVER})
	if(${DRIVER}_FOUND)
		include_directories(${${DRIVER}_INCLUDE_DIR})
		add_definitions(${${DRIVER}_DEFINITIONS})
		string(TOLOWER ${DRIVER} dname)
		set(LIBLUASQL_SRC ${LIBLUASQL_SRC} src/ls_${dname}.cpp)
		set(luasql-libs ${luasql-libs} ${${DRIVER}_LIBRARIES})
		set(WITH_${DRIVER} TRUE)
	endif()
endforeach()

configure_file(luasql/luasql.h.in ${CMAKE_CURRENT_BINARY_DIR}/luasql/luasql.h)

include_directories(src . ${CMAKE_SOURCE_DIR}/liblua ${CMAKE_CURRENT_BINARY_DIR})

add_library(luasql-lib STATIC ${LIBLUASQL_SRC})
target_link_libraries(luasql-lib ${luasql-libs})
set_target_properties(luasql-lib PROPERTIES OUTPUT_NAME luasql)

=== app/gringo/CMakeLists.txt ===
file(GLOB_RECURSE GRINGO_SRC *.cpp *.h)

add_library(appgringo-lib STATIC ${GRINGO_SRC})
set_target_properties(appgringo-lib PROPERTIES OUTPUT_NAME appgringo)

=== debian/changelog ===
gringo (3.0.4-2) unstable; urgency=low

  * debian/patches/gringo-clang-gcc.patch: New file originally from
    https://potassco.svn.sourceforge.net/svnroot/potassco/tags/gringo-3.0.4/patches/patch-clang.diff.
  * Bug fix: "ftbfs with GCC-4.7", thanks to Matthias Klose (Closes:
    #667193).
  * debian/control: Bump Standards-Version to 3.9.3.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 10 Apr 2012 16:48:52 +0200

gringo (3.0.4-1ubuntu1~oneiric1) oneiric; urgency=low

  * Upload to ppa:~tkren/asp.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 27 Jan 2012 08:08:04 +0100

gringo (3.0.4-1) unstable; urgency=low

  * New upstream release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 26 Jan 2012 14:59:59 +0100

gringo (3.0.3-7) unstable; urgency=low

  * debian/copyright: Fix comma-separated-files-in-dep5-copyright,
    obsolete-field-in-dep5-copyright and unversioned-copyright-format-uri
    lintian warnings.
  * Bug fix: "FTBFS: clone_allocator.hpp:34:27: error: invalid use of
    incomplete type <struct Domain>", thanks to Lucas Nussbaum
    (Closes: #652787).
  * debian/patches/gringo-domain-fwd-decl.patch: New file.
  * debian/control: Build-Depends on re2c to recreate parser.cpp from
    parser.r2c, add boost version libboost-*N.MM-dev.
  * debian/rules: Add override_dh_auto_configure and remove parser.cpp and
    converter.cpp to force recreation of re2c lexer files.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 25 Dec 2011 18:44:20 +0100

gringo (3.0.3-6) unstable; urgency=low

  * debian/control: Setup as Debian Science project.
    - Set Maintainer to Debian Science Maintainers and Uploaders to Thomas
      Krennwallner.
    - Set DM-Upload-Allowed to yes.
    - Convert bzr repository to git and use Vcs-Git and Vcs-Browser
      accordingly.
    - Build-Depends on debhelper >= 8.0.0.
  * debian/rules: Add override_dh_auto_build to get rid off
    debian/patches/gringo-makefile.patch.
  * debian/patches/gringo-makefile.patch debian/patches/series: Remove
    debian/patches/gringo-makefile.patch.
    
 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 05 Sep 2011 13:21:51 +0200

gringo (3.0.3-5~natty1) natty; urgency=low

  * debian/watch: Fix lintian debian-watch-contains-dh_make-template.
  * debian/control: Lower Priority to extra and bump Standards-Version to
    3.9.2.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 29 Apr 2011 07:11:12 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,18 @@
 Source: gringo
 Section: interpreters
-Priority: optional
-Maintainer: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
-Build-Depends: debhelper (>= 7.0.50~),
+Priority: extra
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
+DM-Upload-Allowed: yes
+Build-Depends: debhelper (>= 8.0.0),
  cmake,
- libboost-filesystem-dev,
- libboost-system-dev,
+ re2c,
+ libboost-filesystem1.48-dev,
+ libboost-system1.48-dev,
  liblua5.1-dev
-Standards-Version: 3.9.1
-Vcs-Bzr: https://code.launchpad.net/~tkren/+junk/asp/gringo
+Standards-Version: 3.9.3
+Vcs-Git: git://git.debian.org/git/debian-science/packages/gringo.git
+Vcs-Browser: http://git.debian.org/?p=debian-science/packages/gringo.git
 Homepage: http://potassco.sourceforge.net/
 
 Package: gringo

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


%:
	dh $@

# force recreation of re2c parsers
override_dh_auto_configure:
	rm -f libgringo/src/parser.cpp libgringo/src/converter.cpp

# build all {gringo,clingo,iclingo} and use Debian's LUA
override_dh_auto_build:
	dh_auto_build -- target="gringo-app clingo-app iclingo-app" cmake_options="-DWITH_LUA=system -DWITH_LUASQL=1"

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

## gringo 3.0.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,19 @@
 cmake_minimum_required(VERSION 2.6)
+
+if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
+	message(SEND_ERROR  "You have to create an out-of-source build")
+	message(SEND_ERROR  "Create a sub-folder and execute cmake there")
+	message(FATAL_ERROR "The file CmakeCache.txt and directory CMakeFiles in the root directory have to be deleted manually now")
+endif()
+
+project(gringo)
 
 # user configurables
 set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type: Release Debug")
 if(NOT $ENV{WITH_LUA} STREQUAL "")
 	SET(WITH_LUA $ENV{WITH_LUA})
 endif()
-set(WITH_LUA "${WITH_LUA}" CACHE STRING "Enable LUA support (none, system, internal)")
+set(WITH_LUA "${WITH_LUA}" CACHE STRING "Enable LUA support (none, system, shipped)")
 if(NOT $ENV{WITH_LUASQL} STREQUAL "")
 	SET(WITH_LUASQL TRUE)
 endif()
@@ -16,14 +24,10 @@
 set(WITH_DOC "${WITH_DOC}" CACHE BOOL "Generate documentation")
 set(USE_STATIC_LIBS "${USE_STATIC_LIBS}" CACHE BOOL "Link statically")
 
-project(gringo)
-
 include(cmake/re2c.cmake)
 include(cmake/lemon.cmake)
-include(cmake/macros.cmake)
 include(cmake/PCHSupport.cmake)
-
-ENSURE_OUT_OF_SOURCE_BUILD("you have to create an out-of-source build")
+include(CheckCXXCompilerFlag)
 
 set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake CACHE INTERNAL "" FORCE)
 set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin CACHE INTERNAL "" FORCE)
@@ -37,12 +41,21 @@
 	set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS)
 	set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS)
 	set(Boost_USE_STATIC_LIBS TRUE)
-	set(CMAKE_EXE_LINKER_FLAGS ${CMAKE_EXE_LINKER_FLAGS} -static)
+	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
 	set(CMAKE_FIND_LIBRARY_SUFFIXES .lib .a)
 ENDIF()
 
-if(CMAKE_COMPILER_IS_GNUCXX)
+CHECK_CXX_COMPILER_FLAG("-Wno-ignored-qualifiers" HAS_WARN_NO_IGNORED_QUALIFIERS)
+CHECK_CXX_COMPILER_FLAG("-Wno-unused-parameter" HAS_WARN_NO_UNUSED_PARAMETER)
+CHECK_CXX_COMPILER_FLAG("-Wno-unused-variable" HAS_WARN_NO_UNUSED_VARIABLE)
+if(HAS_WARN_NO_IGNORED_QUALIFIERS)
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-ignored-qualifiers")
+endif()
+if(HAS_WARN_NO_UNUSED_PARAMETER)
+#	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-parameter")
+endif()
+if(HAS_WARN_NO_UNUSED_VARIABLE)
+#	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable")
 endif()
 
 set(Boost_USE_MULTITHREADED OFF CACHE STRING "Whether to Use multi-threaded boost libraries")

=== app/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/libgringo ${CMAKE_SOURCE_DIR}/libprogram_opts ${CMAKE_SOURCE_DIR}/libclasp .)

add_subdirectory(gringo)
add_subdirectory(clingo)

set(gringo-libs gringo-lib program_opts-lib ${Boost_LIBRARIES})
if(WITH_LUA STREQUAL "system")
	set(gringo-libs ${gringo-libs} ${LUA_LIBRARIES})
elseif(WITH_LUA STREQUAL "shipped")
	if(WITH_LUASQL)
		set(gringo-libs ${gringo-libs} luasql-lib)
	endif()
	set(gringo-libs ${gringo-libs} lua-lib)
endif()

add_executable(gringo-app gringo.cpp)
target_link_libraries(gringo-app appgringo-lib ${gringo-libs})
set_target_properties(gringo-app PROPERTIES OUTPUT_NAME gringo)

add_executable(clingo-app clingo.cpp)
target_link_libraries(clingo-app appclingo-lib appgringo-lib clasp-lib ${gringo-libs})
set_target_properties(clingo-app PROPERTIES OUTPUT_NAME clingo)

add_executable(iclingo-app iclingo.cpp)
target_link_libraries(iclingo-app appclingo-lib appgringo-lib clasp-lib ${gringo-libs})
set_target_properties(iclingo-app PROPERTIES OUTPUT_NAME iclingo)

=== libgringo/CMakeLists.txt ===
--- 
+++ 
@@ -12,4 +12,6 @@
 target_link_libraries(gringo-lib)
 set_target_properties(gringo-lib PROPERTIES OUTPUT_NAME gringo)
 
-ADD_PRECOMPILED_HEADER(gringo-lib ${CMAKE_SOURCE_DIR}/libgringo/gringo/gringo.h)
+if(PCHSupport_FOUND)
+	ADD_PRECOMPILED_HEADER(gringo-lib ${CMAKE_SOURCE_DIR}/libgringo/gringo/gringo.h)
+endif()

=== liblua/CMakeLists.txt ===
file(GLOB_RECURSE LIBLUA_SRC src/*.cpp *.h)

include_directories(src .)

add_library(lua-lib STATIC ${LIBLUA_SRC})

target_link_libraries(lua-lib)
set_target_properties(lua-lib PROPERTIES OUTPUT_NAME lua)

=== debian/changelog ===
gringo (3.0.5-1build1) trusty; urgency=low

  * No change rebuild for Boost 1.54 transition.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Tue, 22 Oct 2013 09:52:50 +0100

gringo (3.0.5-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright: Update copyright years.
  * debian/compat: Bump to version 9.
  * debian/control:
    - Remove DM-Upload-Allowed.
    - Build-Depends on debhelper >= 9.
  * debian/watch: Only watch upstream gringo >= 3.
  * debian/patches/gringo-clang-gcc.patch debian/patches/gringo-cond.patch
    debian/patches/gringo-domain-fwd-decl.patch
    debian/patches/gringo-unpool-pred.patch debian/patches/series: Remove
    already applied patches.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 21 May 2013 19:04:24 +0200

gringo (3.0.4-4) unstable; urgency=low

  * Apply upstream patches from subversion r6200 and r6237 for fixing
    potassco bugs 75 and 76, resp.
  * debian/patches/gringo-cond.patch: New file originally from
    http://sourceforge.net/p/potassco/code/6291/tree/tags/gringo-3.0.4/patches/patch-cond.diff?format=raw.
  * debian/patches/gringo-unpool-pred.patch: New file originally from
    http://sourceforge.net/p/potassco/code/6291/tree/tags/gringo-3.0.4/patches/patch-unpool-pred.diff?format=raw.
  * debian/control: Bump Standards-Version to 3.9.4.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 22 Nov 2012 10:40:56 +0100

gringo (3.0.4-3) unstable; urgency=low

  * Bug fix: "please build-depend on unversionend boost libraries", thanks
    to Ralf Treinen (Closes: #672933).

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 23 May 2012 15:25:09 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,16 @@
 Source: gringo
 Section: interpreters
 Priority: extra
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
-DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 8.0.0),
+Build-Depends: debhelper (>= 9),
  cmake,
  re2c,
- libboost-filesystem1.48-dev,
- libboost-system1.48-dev,
+ libboost-filesystem-dev,
+ libboost-system-dev,
  liblua5.1-dev
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Vcs-Git: git://git.debian.org/git/debian-science/packages/gringo.git
 Vcs-Browser: http://git.debian.org/?p=debian-science/packages/gringo.git
 Homepage: http://potassco.sourceforge.net/

=== debian/watch ===
# watch control file for uscan

# Compulsory line, this is a version 3 file
version=3

# qa.debian.org runs a redirector which allows a simpler form of URL
# for SourceForge based projects. The format below will automatically
# be rewritten to use the redirector.
http://sf.net/potassco/gringo-3\.([\d\.]+)-source\.tar\.gz

## gringo 4.2.1

=== SConstruct ===
#!/usr/bin/python
# {{{ GPL License

# This file is part of gringo - a grounder for logic programs.
# Copyright (C) 2013  Roland Kaminski

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# }}}

from os import mkdir
from os.path import join, exists

if not exists("build"): mkdir("build")

AddOption('--build-dir', default='release', metavar='DIR', nargs=1, type='string', dest='build_dir')
AddOption('--test-case', default=None, metavar='NAME', nargs=1, type='string', dest='test_case')

# Note: workaround for scons limitation (try to get a hand on the internal option parser)

opts_file = join("build", GetOption('build_dir') + ".py")

opts = Variables(opts_file, ARGUMENTS)
opts.AddVariables(
    ('CXX'           , 'compiler'),
    ('CXXFLAGS'      , 'compiler flags'),
    ('CPPPATH'       , 'include paths'),
    ('CPPDEFINES'    , 'defines'),
    ('LIBS'          , 'additional libraries'),
    ('LIBPATH'       , 'library paths'),
    ('LINKFLAGS'     , 'linker flags'),
    ('AR'            , 'path to ar'),
    ('ARFLAGS'       , 'ar flags'),
    ('RANLIB'        , 'path to ranlib'),
    ('BISON'         , 'path to bison'),
    ('RE2C'          , 'path to re2c'),
    ('WITH_PYTHON'   , 'enable python integration; None to disable or python library name'),
    ('WITH_LUA'      , 'enable lua integration; None to disable or lua library name'),
    ('WITH_TBB'      , 'enable thread support in clasp library; None to disable or tbb library name'),
    ('WITH_CPPUNIT'  , 'enable target test, running unit tests using cppunit; None to disable or cppunit library name'),
    )

env = Environment()
env['BISON']          = 'bison'
env['RE2C']           = 're2c'
env['CXX']            = 'g++'
env['CXXFLAGS']       = ['-std=c++11', '-O0', '-g', '-Wall', '-W', '-pedantic', '-Wno-gnu']
env['LIBS']           = []
env['LINKFLAGS']      = ['-std=c++11', '-O0']
env['CPPDEFINES']     = {}
env['CPPPATH']        = []
env['LIBPATH']        = []
env['WITH_PYTHON']    = None
env['WITH_LUA']       = None
env['WITH_TBB']       = None
env['WITH_CPPUNIT']   = None

if GetOption("build_dir") == "static":
    env['CXXFLAGS']  = ['-std=c++11', '-O3', '-Wall']
    env['LINKFLAGS'] = ['-std=c++11', '-O3', '-static']
    env['CPPDEFINES']['NDEBUG'] = 1
elif GetOption("build_dir") == "release":
    env['CXXFLAGS']   = ['-std=c++11', '-O3', '-Wall']
    env['LINKFLAGS']  = ['-std=c++11', '-O3']
    env['CPPDEFINES']['NDEBUG'] = 1

opts.Update(env)
opts.Save(opts_file, env)
opts.FormatVariableHelpText = lambda env, opt, help, default, actual, other: "%10s: %s (%s)\n" % (opt, help, actual)

Help(
"""
usage: scons [OPTION] [TARGET] ...

Options:
  --build-dir=DIR             Sets the build directory to build/DIR. If DIR is
                              release or static then options are set,
                              respectively. Otherwise, debug options are set.
                              Default: release
  --test-case=NAME            Selects which test case to run. If empty all
                              tests will be executed.
                              Default: ''

Targets:
  gringo                      Build gringo. (default)
  clingo                      Build clingo.
  test-clingo                 Run clingo specific acceptence tests.
  test                        Build and run unit tests.
  tags                        Generate ctags file.
  configure                   Only configure and build nothing.

Variables:
""" + opts.GenerateHelpText(env))

# Notes to use gold linker:
#   scons --build=gold \
#     CXXFLAGS="-std=c++11 -O4 -Wall" \
#     LINKFLAGS="-O4 -B build/gold/ld-gold/" \
#     RANLIB=true \
#     ARFLAGS="rc --plugin /usr/lib/llvm/LLVMgold.so"

# Notes to set rpath:
#   scons --build=release \
#     LINKFLAGS="-Wl,-rpath -Wl,/home/wv/bin/linux/64/gcc-4.7/lib"

if not env.GetOption('help'):
    SConscript('SConscript', variant_dir=join('build', GetOption('build_dir')), duplicate=0, exports=['env', 'opts'])

=== debian/changelog ===
gringo (4.2.1-4) unstable; urgency=low

  * Bug fix: "add ppc64el to architecture list for libtbb-dev to fix
    FTBFS", thanks to Logan Rosen (Closes: #735005).

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 12 Jan 2014 19:22:44 +0100

gringo (4.2.1-3) unstable; urgency=low

  * debian/control: Breaks aspcud <= 2012.10.24-6 after discussion with
    upstream.
    Remove spurious Build-Depends on libboost-filesystem-dev and
    libboost-system-dev.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 18 Dec 2013 09:42:59 +0100

gringo (4.2.1-2) unstable; urgency=low

  * debian/control: FTBFS on ia64 sparc powerpc, Build-Depends is now
    g++-4.8 >= 4.8.0.
  * debian/rules: Set CXX to g++-4.8.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 17 Dec 2013 07:07:54 +0100

gringo (4.2.1-1) unstable; urgency=low

  gringo 4.2 adds support for {i,o,}clingo again.

  * New upstream release.
  * debian/watch: Back to watching all releases of gringo.
  * debian/rules: Add scons, python, tbb, and hardening support.
  * debian/install: Install gringo and clingo.
  * debian/gringo.links: Symlink clingo binary and manpage to {i,o}clingo.
  * debian/gringo.manpages: Remove iclingo manpage.
  * debian/control: Build-Depends on bison, scons, g++ >= 4.8.0,
    libpython2.7-dev, libtbb-dev.
    Bump Standards-Version to 3.9.5.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 16 Dec 2013 16:28:42 +0100

=== debian/control ===
Source: gringo
Section: interpreters
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
Build-Depends: debhelper (>= 9),
 g++-4.8 (>= 4.8.0),
 scons,
 re2c,
 bison,
 libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64 ppc64el],
 liblua5.1-dev,
 libpython2.7-dev
Standards-Version: 3.9.5
Vcs-Git: git://git.debian.org/git/debian-science/packages/gringo.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/gringo.git
Homepage: http://potassco.sourceforge.net/

Package: gringo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: clasp
Suggests: potassco-guide
Replaces: clingo, iclingo
Conflicts: clingo, iclingo
Breaks: aspcud (<= 2012.10.24-6)
Description: grounding tools for (disjunctive) logic programs
 Current answer set solvers work on variable-free programs. Hence, a
 grounder is needed that, given an input program with first-order
 variables, computes an equivalent ground (variable-free) program.
 .
 This package contains the following tools:
 .
  - gringo: creates lparse-compatible variable-free programs.
  - clingo: stands for clasp on gringo and combines both systems in
    a monolithic way. Its input language is that of gringo and its
    output corresponds to that of clasp.
  - iclingo: an incremental answer set programming system, which is
    based on the idea that the grounder as well as the solver are
    implemented in a stateful way.  Thus, both keep their previous states
    while increasing an incremental parameter. As regards grounding, at
    each incremental step, the goal is to produce only ground rules
    stemming from the current program slice, without re-producing
    previous ground rules.  The ground program slices are then gradually
    passed to the solver that accumulates ground rules and computes
    answer sets for them.
  - oclingo: a system for reactive answer set programming, extending
    gringo and clasp for handling external modules provided at runtime
    by a controller.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# compile with libtbb-dev only with linux 64bit intel/ppc architectures,
# fallback in pentium4 processors is not implemented, see also note of
# libtbb-dev:
#
# Note: if you are a user of the i386 architecture, i.e., 32-bit Intel
# or compatible hardware, this package only supports Pentium4-compatible
# and higher processors.
#
arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep "(amd64|ia64|ppc64)")
os = $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS | grep linux)

# force g++-4.8, lua5.1, and python2.7
CONFIGPARMS = CXX='g++-4.8' WITH_LUA='lua5.1' WITH_PYTHON='python2.7' CPPPATH='$${["/usr/include/lua5.1","/usr/include/python2.7"]}'
ifeq ($(and $(if $(os),good), $(if $(arch),good)), good)
	CONFIGPARMS += WITH_TBB="tbb"
endif

#
# export CPPFLAGS, CXXFLAGS, and LDFLAGS for scons
#
# default to -O3 -std=c++11 -Wall -DNDEBUG and enable all hardening flags
#
DEB_CXXFLAGS_MAINT_APPEND = -std=c++11 -O3 -Wall
DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# inject compiler and linker flags to scons variables
SCCXXFLAGS =  $(shell echo $(CXXFLAGS) $(CPPFLAGS) | sed -e 's/^/\$${["/;s/ -/","-/g;s/$$/"]}/')
SCLINKFLAGS = $(shell echo $(LDFLAGS) | sed -e 's/^/\$${["/;s/ -/","-/g;s/$$/"]}/')

%:
	dh $@

# configure with LUA, Python, and possibly TBB
override_dh_auto_configure:
	scons configure --build-dir=release $(CONFIGPARMS) CXXFLAGS='$(SCCXXFLAGS)' LINKFLAGS='$(SCLINKFLAGS)'

# build gringo and clingo
override_dh_auto_build:
	scons --build-dir=release gringo clingo

override_dh_auto_clean:
	rm -rf ./build .sconf_temp .sconsign.dblite

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

## gringo 4.3.0

=== debian/changelog ===
gringo (4.3.0-2) unstable; urgency=low

  * Bug fix: "non-standard gcc/g++ used for build (gcc-4.8)", thanks to
    Matthias Klose (Closes: #751317).
  * Build with system-wide liblua5.2-dev.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 12 Jun 2014 09:16:31 +0200

gringo (4.3.0-1) unstable; urgency=low

  * New upstream release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 26 Feb 2014 13:06:29 +0100

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,12 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
 Build-Depends: debhelper (>= 9),
- g++-4.8 (>= 4.8.0),
+ g++ (>= 4:4.8.0),
  scons,
  re2c,
  bison,
  libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64 ppc64el],
- liblua5.1-dev,
+ liblua5.2-dev,
  libpython2.7-dev
 Standards-Version: 3.9.5
 Vcs-Git: git://git.debian.org/git/debian-science/packages/gringo.git

## gringo 4.4.0

=== SConstruct ===
--- 
+++ 
@@ -87,7 +87,7 @@
   --build-dir=DIR             Sets the build directory to build/DIR. If DIR is
                               release or static then options are set,
                               respectively. Otherwise, debug options are set.
-                              Default: release
+                              Default: debug
   --test-case=NAME            Selects which test case to run. If empty all
                               tests will be executed.
                               Default: ''

=== debian/changelog ===
gringo (4.4.0-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Remove Suggests on potassco-guide.
  * debian/control: Fix Vcs fields to use anonscm.debian.org.
  * Setup git repository to use git-buildpackage.
  * Import upstream sources with git-import-orig --pristine-tar.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 18 Aug 2014 17:10:34 +0200

=== debian/control ===
--- 
+++ 
@@ -12,15 +12,14 @@
  liblua5.2-dev,
  libpython2.7-dev
 Standards-Version: 3.9.5
-Vcs-Git: git://git.debian.org/git/debian-science/packages/gringo.git
-Vcs-Browser: http://git.debian.org/?p=debian-science/packages/gringo.git
+Vcs-Git: git://anonscm.debian.org/debian-science/packages/gringo.git
+Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/packages/gringo.git
 Homepage: http://potassco.sourceforge.net/
 
 Package: gringo
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: clasp
-Suggests: potassco-guide
 Replaces: clingo, iclingo
 Conflicts: clingo, iclingo
 Breaks: aspcud (<= 2012.10.24-6)

=== debian/rules ===
--- 
+++ 
@@ -15,8 +15,8 @@
 arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep "(amd64|ia64|ppc64)")
 os = $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS | grep linux)
 
-# force g++-4.8, lua5.1, and python2.7
-CONFIGPARMS = CXX='g++-4.8' WITH_LUA='lua5.1' WITH_PYTHON='python2.7' CPPPATH='$${["/usr/include/lua5.1","/usr/include/python2.7"]}'
+# force g++, lua5.2, and python2.7
+CONFIGPARMS = CXX='g++' WITH_LUA='lua5.2' WITH_PYTHON='python2.7' CPPPATH='$${["/usr/include/lua5.2","/usr/include/python2.7"]}'
 ifeq ($(and $(if $(os),good), $(if $(arch),good)), good)
 	CONFIGPARMS += WITH_TBB="tbb"
 endif

## gringo 4.5.0

=== SConstruct ===
--- 
+++ 
@@ -40,6 +40,7 @@
     ('LIBS'          , 'additional libraries'),
     ('LIBPATH'       , 'library paths'),
     ('LINKFLAGS'     , 'linker flags'),
+    ('RPATH'         , 'library paths to embedd into binaries'),
     ('AR'            , 'path to ar'),
     ('ARFLAGS'       , 'ar flags'),
     ('RANLIB'        , 'path to ranlib'),
@@ -55,12 +56,13 @@
 env['BISON']          = 'bison'
 env['RE2C']           = 're2c'
 env['CXX']            = 'g++'
-env['CXXFLAGS']       = ['-std=c++11', '-O0', '-g', '-Wall', '-W', '-pedantic', '-Wno-gnu']
+env['CXXFLAGS']       = ['-std=c++11', '-O0', '-g', '-Wall', '-W', '-pedantic']
 env['LIBS']           = []
 env['LINKFLAGS']      = ['-std=c++11', '-O0']
 env['CPPDEFINES']     = {}
 env['CPPPATH']        = []
 env['LIBPATH']        = []
+env['RPATH']          = []
 env['WITH_PYTHON']    = None
 env['WITH_LUA']       = None
 env['WITH_TBB']       = None
@@ -87,14 +89,17 @@
   --build-dir=DIR             Sets the build directory to build/DIR. If DIR is
                               release or static then options are set,
                               respectively. Otherwise, debug options are set.
-                              Default: debug
+                              Default: release
   --test-case=NAME            Selects which test case to run. If empty all
                               tests will be executed.
                               Default: ''
 
 Targets:
-  gringo                      Build gringo. (default)
-  clingo                      Build clingo.
+  gringo                      Build gringo (built by default).
+  clingo                      Build clingo (built by default).
+  reify                       Build reify (built by default).
+  pyclingo                    Python module (built if python support enabled).
+  luaclingo                   Lua module (built if lua support enabled).
   test-clingo                 Run clingo specific acceptence tests.
   test                        Build and run unit tests.
   tags                        Generate ctags file.

=== debian/changelog ===
gringo (4.5.0-1) unstable; urgency=medium

  * Bump Standards-Version to 3.9.6.
  * Imported Upstream version 4.5.0
  * debian/control: Add Breaks: aspcud (<= 1.9.0-2). Add reify description.
  * debian/copyright: Update copyright information, remove outdated files.
  * debian/docs: Remove NOTES.
  * debian/install: Install reify.
  * debian/rules: Build reify.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 11 Jul 2015 09:36:10 +0200

## gringo 4.5.1

=== SConstruct ===
--- 
+++ 
@@ -46,10 +46,10 @@
     ('RANLIB'        , 'path to ranlib'),
     ('BISON'         , 'path to bison'),
     ('RE2C'          , 'path to re2c'),
-    ('WITH_PYTHON'   , 'enable python integration; None to disable or python library name'),
-    ('WITH_LUA'      , 'enable lua integration; None to disable or lua library name'),
-    ('WITH_TBB'      , 'enable thread support in clasp library; None to disable or tbb library name'),
-    ('WITH_CPPUNIT'  , 'enable target test, running unit tests using cppunit; None to disable or cppunit library name'),
+    ('WITH_PYTHON'   , 'enable python integration; None, "auto", or library name or path'),
+    ('WITH_LUA'      , 'enable lua integration; None, "auto", library name, or path'),
+    ('WITH_TBB'      , 'enable thread support in clasp library using tbb; None, "auto", library name or path'),
+    ('WITH_CPPUNIT'  , 'enable target test, running unit tests using cppunit; None, "auto", or library name or test'),
     )
 
 env = Environment()
@@ -63,10 +63,10 @@
 env['CPPPATH']        = []
 env['LIBPATH']        = []
 env['RPATH']          = []
-env['WITH_PYTHON']    = None
-env['WITH_LUA']       = None
-env['WITH_TBB']       = None
-env['WITH_CPPUNIT']   = None
+env['WITH_PYTHON']    = 'auto'
+env['WITH_LUA']       = 'auto'
+env['WITH_TBB']       = 'auto'
+env['WITH_CPPUNIT']   = 'auto'
 
 if GetOption("build_dir") == "static":
     env['CXXFLAGS']  = ['-std=c++11', '-O3', '-Wall']
@@ -89,7 +89,7 @@
   --build-dir=DIR             Sets the build directory to build/DIR. If DIR is
                               release or static then options are set,
                               respectively. Otherwise, debug options are set.
-                              Default: release
+                              Default: debug
   --test-case=NAME            Selects which test case to run. If empty all
                               tests will be executed.
                               Default: ''
@@ -115,10 +115,6 @@
 #     RANLIB=true \
 #     ARFLAGS="rc --plugin /usr/lib/llvm/LLVMgold.so"
 
-# Notes to set rpath:
-#   scons --build=release \
-#     LINKFLAGS="-Wl,-rpath -Wl,/home/wv/bin/linux/64/gcc-4.7/lib"
-
 if not env.GetOption('help'):
     SConscript('SConscript', variant_dir=join('build', GetOption('build_dir')), duplicate=0, exports=['env', 'opts'])

=== debian/changelog ===
gringo (4.5.1-1) unstable; urgency=medium

  * Imported Upstream version 4.5.1
  * Add reify.1 manpage

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 13 Jul 2015 09:01:56 +0200

## gringo 4.5.3

=== SConstruct ===
--- 
+++ 
@@ -76,6 +76,17 @@
     env['CXXFLAGS']   = ['-std=c++11', '-O3', '-Wall']
     env['LINKFLAGS']  = ['-std=c++11', '-O3']
     env['CPPDEFINES']['NDEBUG'] = 1
+elif GetOption("build_dir") == "js":
+    env['CXXFLAGS']   = ['-std=c++11', '-Os', '-Wall', '-s', 'DISABLE_EXCEPTION_CATCHING=0']
+    env['LINKFLAGS']  = ['-std=c++11', '-Os', '-s', 'DISABLE_EXCEPTION_CATCHING=0', '-s', 'EXPORTED_FUNCTIONS=\'["_run"]\'']
+    env['CXX'] = "em++"
+    env['AR'] = 'emar'
+    env['RANLIB'] = 'emranlib'
+    env['CPPDEFINES']['NDEBUG'] = 1
+    env['WITH_PYTHON'] = None
+    env['WITH_LUA'] = None
+    env['WITH_TBB'] = None
+    env['WITH_CPPUNIT'] = None
 
 opts.Update(env)
 opts.Save(opts_file, env)
@@ -89,12 +100,16 @@
   --build-dir=DIR             Sets the build directory to build/DIR. If DIR is
                               release or static then options are set,
                               respectively. Otherwise, debug options are set.
+                              Furthermore the special build dir js sets options
+                              to build with emscripten. Afterwards, target web
+                              can be used to build clingo for the web browser.
                               Default: debug
   --test-case=NAME            Selects which test case to run. If empty all
                               tests will be executed.
                               Default: ''
 
 Targets:
+  configure                   Only configure and build nothing.
   gringo                      Build gringo (built by default).
   clingo                      Build clingo (built by default).
   reify                       Build reify (built by default).
@@ -102,8 +117,10 @@
   luaclingo                   Lua module (built if lua support enabled).
   test-clingo                 Run clingo specific acceptence tests.
   test                        Build and run unit tests.
+  libclingo                   Build shared clingo library.
+  example                     Build example app using libclingo.
   tags                        Generate ctags file.
-  configure                   Only configure and build nothing.
+  web                         Build clingo for the web (use with build-dir js).
 
 Variables:
 """ + opts.GenerateHelpText(env))

=== debian/changelog ===
gringo (4.5.3-1) unstable; urgency=medium

  * Imported Upstream version 4.5.3

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 26 Sep 2015 09:31:03 +0200

## gringo 4.5.4

=== SConstruct ===
--- 
+++ 
@@ -24,7 +24,7 @@
 
 if not exists("build"): mkdir("build")
 
-AddOption('--build-dir', default='release', metavar='DIR', nargs=1, type='string', dest='build_dir')
+AddOption('--build-dir', default='debug', metavar='DIR', nargs=1, type='string', dest='build_dir')
 AddOption('--test-case', default=None, metavar='NAME', nargs=1, type='string', dest='test_case')
 
 # Note: workaround for scons limitation (try to get a hand on the internal option parser)
@@ -46,6 +46,8 @@
     ('RANLIB'        , 'path to ranlib'),
     ('BISON'         , 'path to bison'),
     ('RE2C'          , 'path to re2c'),
+    ('PYTHON_CONFIG' , 'path to python-config'),
+    ('PKG_CONFIG'    , 'path to pkg-config'),
     ('WITH_PYTHON'   , 'enable python integration; None, "auto", or library name or path'),
     ('WITH_LUA'      , 'enable lua integration; None, "auto", library name, or path'),
     ('WITH_TBB'      , 'enable thread support in clasp library using tbb; None, "auto", library name or path'),
@@ -55,6 +57,8 @@
 env = Environment()
 env['BISON']          = 'bison'
 env['RE2C']           = 're2c'
+env['PYTHON_CONFIG']  = 'python-config'
+env['PKG_CONFIG']     = 'pkg-config'
 env['CXX']            = 'g++'
 env['CXXFLAGS']       = ['-std=c++11', '-O0', '-g', '-Wall', '-W', '-pedantic']
 env['LIBS']           = []

=== debian/changelog ===
gringo (4.5.4-1) unstable; urgency=medium

  * Imported Upstream version 4.5.4

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 19 Dec 2015 14:07:05 +0100

=== debian/control ===
Source: gringo
Section: interpreters
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
Build-Depends: debhelper (>= 9),
 g++ (>= 4:4.8.0),
 scons,
 re2c,
 bison,
 libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64 ppc64el],
 liblua5.2-dev,
 libpython2.7-dev
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/debian-science/packages/gringo.git
Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/packages/gringo.git
Homepage: http://potassco.sourceforge.net/

Package: gringo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: clasp
Replaces: clingo, iclingo
Conflicts: clingo, iclingo
Breaks: aspcud (<= 1.9.0-2)
Description: grounding tools for (disjunctive) logic programs
 Current answer set solvers work on variable-free programs. Hence, a
 grounder is needed that, given an input program with first-order
 variables, computes an equivalent ground (variable-free) program.
 .
 This package contains the following tools:
 .
  - gringo: creates lparse-compatible variable-free programs.
  - clingo: stands for clasp on gringo and combines both systems in
    a monolithic way. Its input language is that of gringo and its
    output corresponds to that of clasp.
  - reify: small utility that reifies logic program, given in smodels
    format.  It produces a set of facts that can be processed further
    with gringo.

=== debian/rules ===
--- 
+++ 
@@ -44,9 +44,9 @@
 override_dh_auto_configure:
 	scons configure --build-dir=release $(CONFIGPARMS) CXXFLAGS='$(SCCXXFLAGS)' LINKFLAGS='$(SCLINKFLAGS)'
 
-# build gringo and clingo
+# build gringo clingo reify
 override_dh_auto_build:
-	scons --build-dir=release gringo clingo
+	scons --build-dir=release gringo clingo reify
 
 override_dh_auto_clean:
 	rm -rf ./build .sconf_temp .sconsign.dblite

=== debian/watch ===
# watch control file for uscan

# Compulsory line, this is a version 3 file
version=3

# qa.debian.org runs a redirector which allows a simpler form of URL
# for SourceForge based projects. The format below will automatically
# be rewritten to use the redirector.
http://sf.net/potassco/gringo-([\d\.]+)-source\.tar\.gz
